<?php
define("UPPER","[A-Z\xc0-\xdf\xa8]");
define("UPPERNUM","[0-9A-Z\xc0-\xdf\xa8]");
define("LOWER","[a-z\xe0-\xff\xb8\/]");
define("ALPHA","[A-Za-z\xc0-\xff\xa8\xb8\_\-\/]");
define("ALPHANUM","[0-9A-Za-z\xc0-\xff\xa8\xb8\_\-\/]");
define("ALPHANUM_P","0-9A-Za-z\xc0-\xff\xa8\xb8\_\-\/");
setlocale(LC_CTYPE,'ru_RU.CP1251');

error_reporting (E_ALL ^ E_NOTICE);

ob_start("ob_gzhandler");


// time measuring
$ttt=microtime();
$ttt=((double)strstr($ttt, ' ')+(double)substr($ttt,0,strpos($ttt,' ')));

// do not change this two lines, PLEASE-PLEASE. In fact, don't change anything! Ever!
define("WAKKA_VERSION", "0.1.2");
define("WACKO_VERSION", "R3");

class Wakka
{
  var $dblink;
  var $page;
  var $tag;
  var $queryLog = array();
  var $interWiki = array();
  var $VERSION;
  var $WVERSION;//Wacko version
  var $context = array("");
  var $current_context = 0;
  var $headerCount;         // used in wakka formatter for {{TOC}} <a href=#> functionale
  var $tocAutoNumerate = 0; // sets in {{TOC}} if parameter set, used in wakka formatter furthermore.
  var $tocRecursionTag = ""; // inserts between <A name="Toc.. & ..XX"> to stop TOC`ing deeper
  var $pages_meta = "id, tag, time, owner, user, latest, handler, comment_on, supertag";

  // constructor
  function Wakka($config)
  {
    $this->config = $config;
    $this->dblink = connect($this->config["mysql_host"], $this->config["mysql_user"], $this->config["mysql_password"], $this->config["mysql_database"]);
    $this->VERSION = WAKKA_VERSION;
    $this->WVERSION = WACKO_VERSION;
  }

  // DATABASE
  function Query($query, $debug=0)
  {
    if ($debug) echo "((QUERY: $query))";
    if($this->GetConfigValue("debug")>=2) $start = $this->GetMicroTime();
    $result = query($query, $this->dblink);
    if($this->GetConfigValue("debug")>=2)
    {
      $time = $this->GetMicroTime() - $start;
      $this->queryLog[] = array(
        "query"   => $query,
        "time"    => $time);
    }
    return $result;
  }
  function LoadSingle($query) { if ($data = $this->LoadAll($query)) return $data[0]; }
  function LoadAll($query)
  {
    if ($r = $this->Query($query))
    {
      while ($row = fetch_assoc($r)) $data[] = $row;
      free_result($r);
    }
    return $data;
  }


  // MISC
  function GetMicroTime() { list($usec, $sec) = explode(" ",microtime()); return ((float)$usec + (float)$sec); }
  function IncludeBuffered($filename, $notfoundText = "", $vars = "", $path = "")
  {
    if ($path) $dirs = explode(":", $path);
    else $dirs = array("");

    foreach($dirs as $dir)
    {
      if ($dir) $dir .= "/";
      $fullfilename = $dir.$filename;
      if (file_exists($fullfilename))
      {
        if (is_array($vars)) extract($vars);

        ob_start();
        include($fullfilename);
        $output = ob_get_contents();
        ob_end_clean();
        return $output;
      }
    }
    if ($notfoundText) return $notfoundText;
    else return false;
  }

  // VARIABLES
  function GetPageTag() { return $this->tag; }
  function GetPageSuperTag() { return $this->supertag; }
  function GetPageTime() { return $this->page["time"]; }
  function GetMethod() { return $this->method; }
  function GetConfigValue($name) { return $this->config[$name]; }
  function SetResource($resource) {$this->resource=$resource;}
  function GetResourceValue($name) { return $this->resource[$name];}
  function GetWakkaName() { return $this->GetConfigValue("wakka_name"); }
  function GetWakkaVersion() { return $this->VERSION; }
  function GetWackoVersion() { return $this->WVERSION; }

  // PAGES
    // 
    var $NpjMacros = array( "" => "wiki", "" => "wacko", "" => "shwacko",
                            "" => "web", "" => "lance", "" => "kukutz", "" => "mendokusee",
                            "" => "iaremko", "" => "nikolai", "" => "aleksey", "" => "anatoly"
                          );
    var $NpjLettersFrom = "";
    var $NpjLettersTo   = "abvgdeziklmnoprstufx__cyABVGDEZIKLMNOPRSTUFX__CY";
    var $NpjBiLetters = array( 
      "" => "jj", "" => "jo", "" => "zh", "" => "ch", 
      "" => "sh", "" => "shh", "" => "je", "" => "ju", "" => "ja",
      "" => "Jj", "" => "Jo", "" => "Zh", "" => "Ch", 
      "" => "Sh", "" => "Shh", "" => "Je", "" => "Ju", "" => "Ja",
    );
    function NpjTranslit($tag, $strtolow = 1)
    {
      $tag = str_replace( "//", "/", $tag );
      $tag = str_replace( "-", "", $tag );
      $tag = str_replace( " ", "", $tag );
      $_tag = strtolower( $tag ); 
      if ($strtolow) $tag = strtr( $_tag, $this->NpjMacros ); 
      else 
       foreach( $this->NpjMacros as $macro=>$value ) 
        while (($pos = strpos($_tag, $macro)) !== false) 
        { 
          $_tag = substr_replace( $_tag, $value, $pos, strlen($macro) ); 
          $tag = substr_replace( $tag, ucfirst($value), $pos, strlen($macro) ); 
        } 
 
      $tag = strtr( $tag, $this->NpjLettersFrom, $this->NpjLettersTo ); 
      $tag = strtr( $tag, $this->NpjBiLetters ); 
      return rtrim($tag, "/"); 
    }
  var $Tran = array (
   "" => "A",  "" => "B",  "" => "V",  "" => "G",  "" => "D",  "" => "E",  "" => "JO",  "" => "ZH",  "" => "Z",  "" => "I",
   "" => "JJ", "" => "K",  "" => "L",  "" => "M",  "" => "N",  "" => "O",  "" => "P",   "" => "R",   "" => "S",  "" => "T",
   "" => "U",  "" => "F",  "" => "X",  "" => "C",  "" => "CH", "" => "SH", "" => "SHH", "" => "~",   "" => "Y",  "" => "_",
   "" => "JE", "" => "JU", "" => "JA", "" => "a",  "" => "b",  "" => "v",  "" => "g",   "" => "d",   "" => "e",  "" => "jo",
   "" => "zh", "" => "z",  "" => "i",  "" => "jj", "" => "k",  "" => "l",  "" => "m",   "" => "n",   "" => "o",  "" => "p",
   "" => "r",  "" => "s",  "" => "t",  "" => "u",  "" => "f",  "" => "x",  "" => "c",   "" => "ch",  "" => "sh", "" => "shh",
   "" => "~",  "" => "y",  "" => "'",  "" => "je", "" => "ju", "" => "ja", );
  var $DeTran = array (
   "A"    => "",   "B"    => "",  "V"    => "",  "G"    => "",  "D"    => "",  "E"    => "",  "JO"   => "",  "ZH"   => "",
   "Z"    => "",   "I"    => "",  "JJ"   => "",  "K"    => "",  "L"    => "",  "M"    => "",  "N"    => "",  "O"    => "",
   "P"    => "",   "R"    => "",  "S"    => "",  "T"    => "",  "U"    => "",  "F"    => "",  "X"    => "",  "C"    => "",
   "CH"   => "",   "SHH"  => "",  "SH"   => "",  "~"    => "",  "Y"    => "",  "_"    => "",  "JE"   => "",  "JU"   => "",
   "JA"   => "",   "a"    => "",  "b"    => "",  "v"    => "",  "g"    => "",  "d"    => "",  "e"    => "",  "jo"   => "",
   "zh"   => "",   "z"    => "",  "i"    => "",  "jj"   => "",  "k"    => "",  "l"    => "",  "m"    => "",  "n"    => "",
   "o"    => "",   "p"    => "",  "r"    => "",  "s"    => "",  "t"    => "",  "u"    => "",  "f"    => "",  "x"    => "",
   "c"    => "",   "ch"   => "",  "shh"  => "",  "sh"   => "",  "~"    => "",  "y"    => "",  "_"    => "",  "je"   => "",
   "ju"   => "",   "ja"   => "",  "'"=>"");            
  function Translit($tag, $direction=1) {
   $tag = str_replace( "//", "/", $tag );
   if ($direction==1) {
    $pgs = explode("/", $tag);
    for ($j=0;$j<count($pgs);$j++) {
      $tags = explode("-", $pgs[$j]);
      for ($i=1;$i<count($tags);$i=$i+2)
        $tags[$i] = strtr($tags[$i], $this->DeTran);
      $pgs[$j] = implode("", $tags);
    }
    $tag = implode("/", $pgs);
   } else {
    $russians = preg_split('/[0-9A-Za-z\_\.\/\']+/', $tag, -1, PREG_SPLIT_NO_EMPTY);//\xc0-\xff
    for ($i=0;$i<count($russians);$i++)
      $russians[$i] = strtr($russians[$i], $this->Tran);
    $others = preg_split('/[\xc0-\xff\xa8\xb8]+/', $tag, -1, PREG_SPLIT_NO_EMPTY); 
    if (preg_match('/[\xc0-\xff\xa8\xb8]/', $tag[0])) {      
      $fr="russians";
      $sr="others";
      $tag = "-";
    } else { 
      $fr="others";
      $sr="russians";
      $tag = "";
    }
    for ($i=0;$i<min(count($$fr),count($$sr));$i++)
     $tag.=${$fr}[$i]."-".${$sr}[$i]."-";
    if (count($$fr)>count($$sr))
      $tag.=${$fr}[count($$fr)-1];
    else
      $tag=substr($tag,0,strlen($tag)-1);
   }
   return rtrim($tag, "/");
  }
  function LoadPage($tag, $time = "", $cache = 1, $metadataonly = 0) {
    $supertag = $this->NpjTranslit($tag);
    if ($this->GetCachedWantedPage($supertag)==1) return "";

    $page = $this->OldLoadPage($supertag,$time,$cache, true, $metadataonly);     // 1. search for supertag
    if (!$page)                                      // 2. if not found, search for tag 
    {
      $page = $this->OldLoadPage($tag,$time,$cache, false, $metadataonly);
      if ($page)                                     // 3. if found, update supertag
      {
        $this->Query( "update ".$this->config["table_prefix"]."pages ".
                      "set supertag='".$supertag."' where tag = '".$tag."';" );
      }
    }

    if (!$page) $this->CacheWantedPage($supertag);
    return $page;
  }
  function OldLoadPage($tag, $time = "", $cache = 1, $supertagged = false, $metadataonly = 0) {
    if (!$supertagged) $supertag = $this->NpjTranslit($tag);
    else $supertag=$tag;
    // retrieve from cache
    if (!$time && $cache && ($cachedPage = $this->GetCachedPage($supertag, $metadataonly))) $page = $cachedPage;
    // load page
    if ($metadataonly) $what = $this->pages_meta;
    else $what = "*";
    if (!$page) 
      if ($supertagged) {
        $page = $this->LoadSingle("select ".$what." from ".$this->config["table_prefix"]."pages where supertag='".quote($tag)."' and latest = 'Y' limit 1");
        if ($time && $time!=$page["time"]) {
          $this->CachePage($page, $metadataonly);
          $page = $this->LoadSingle("select ".$what." from ".$this->config["table_prefix"]."revisions where supertag='".quote($tag)."' and time = '".quote($time)."' limit 1");
        }
      }
      else {
        $page = $this->LoadSingle("select ".$what." from ".$this->config["table_prefix"]."pages where STRCMP(tag,'".quote($tag)."')=0 and latest = 'Y' limit 1");
        if ($time && $time!=$page["time"]) {
          $this->CachePage($page, $metadataonly);
          $page = $this->LoadSingle("select ".$what." from ".$this->config["table_prefix"]."revisions where STRCMP(tag,'".quote($tag)."')=0 and time = '".quote($time)."' limit 1");
        }
      }
    // cache result
    if (!$time) $this->CachePage($page, $metadataonly);
    return $page;
  }
  function GetCachedPage($tag, $metadataonly=0) { 

   if ($this->pageCache[$tag]["mdonly"]==0 || $metadataonly==$this->pageCache[$tag]["mdonly"])
     return $this->pageCache[$tag]; 
   else 
     return false;
  }
  function CachePage($page, $metadataonly=0) { 
   $page["supertag"] = $this->NpjTranslit($page["supertag"]);
   $this->pageCache[$page["supertag"]] = $page;
   $this->pageCache[$page["supertag"]]["mdonly"] = $metadataonly;
  }
  function CacheWantedPage($tag, $check = 0) { 
   if ($check==0)
     $this->wantedCache[$tag] = 1;  
   else if ($this->OldLoadPage($tag, "", 1, false, 1)=="")
     $this->wantedCache[$tag] = 1;  
  }
  function ClearCacheWantedPage($tag){
    $this->wantedCache[$tag] = 0;  
  }
  function GetCachedWantedPage($tag) { return $this->wantedCache[$tag];  }
  function GetCachedACL($tag, $privilege, $useDefaults) { return $this->aclCache[$tag."#".$privilege."#".$useDefaults]; }
  function CacheACL($tag, $privilege, $useDefaults, $acl) { $this->aclCache[$tag."#".$privilege."#".$useDefaults] = $acl; }
  function CacheLinks() 
  { 
   if ($links = $this->LoadAll("select * from ".$this->config["table_prefix"]."links where  STRCMP(from_tag, '".quote($this->GetPageTag())."')=0")) {
     $cl = count($links);
     for ($i=0; $i<$cl; $i++)
       $pages[$i] = $links[$i]["to_tag"];
   }

   $user = $this->GetUser();
   $pages[$cl] = $user["name"]; 


   $bookm = $this->config["site_bookmarks"]."\n".($user["bookmarks"] ? $user["bookmarks"] : $this->config["default_bookmarks"]);
   $bookmarks = explode("\n", $bookm);
   for ($i=0; $i<=count($bookmarks); $i++)
     $pages[$cl+$i] = preg_replace("/^(.*?)\s.*$/","\\1",preg_replace("/[\[\]\(\)]/","",$bookmarks[$i]));

   $pages[]=$this->GetPageTag();

   for ($i=0; $i<count($pages); $i++) {
     $spages[$i] = $this->NpjTranslit($pages[$i]);
     $pages_str .= "'".quote($spages[$i])."', ";
   }
   
   $pages_str=substr($pages_str,0,strlen($pages_str)-2);

   if ($links = $this->LoadAll("select ".$this->pages_meta." from ".$this->config["table_prefix"]."pages where supertag in (".$pages_str.")"))
     for ($i=0; $i<count($links); $i++) {
       $this->CachePage($links[$i], 1);
       $exists[] = $links[$i]["supertag"];
     }
   $notexists = @array_values(@array_diff($spages, $exists));
   for ($i=0; $i<count($notexists); $i++) 
     $this->CacheWantedPage($pages[array_search($notexists[$i],$spages)], 1);

   unset($exists);
   if ($read_acls = $this->LoadAll("select * from ".$this->config["table_prefix"]."acls where supertag in (".$pages_str.") and privilege = 'read'"))
     for ($i=0; $i<count($read_acls); $i++) {
       $this->CacheACL($read_acls[$i]["supertag"], "read", 1,$read_acls[$i]);
       $exists[] = $read_acls[$i]["supertag"];
     }
   $notexists = @array_values(@array_diff($pages, $exists));
   for ($i=0; $i<count($notexists); $i++) {
     $acl = array("supertag" => $notexists[$i], "page_tag" => $notexists[$i], "privilege" => "read", "list" => "*", "time" => date("YmdHis"));
     $this->CacheACL($notexists[$i], "read", 1, $acl);
   }
$ddd=microtime();$ddd=((double)strstr($ddd, ' ')+(double)substr($ddd,0,strpos($ddd,' ')));GLOBAL $ttt;
   $this->queryLog[] = array(
     "query"   => "<b>end caching links</b>",
     "time"    => " : ".(number_format(($ddd-$ttt),3))." ");
  }
  function SetPage($page) { $this->page = $page; if ($this->page["tag"]) $this->tag = $this->page["tag"]; }
  function LoadPageById($id) 
  { 
   if ($id!="-1")
    return $this->LoadSingle("select * from ".$this->config["table_prefix"]."revisions where id = '".quote($id)."' limit 1"); 
   else
    return $this->LoadSingle("select * from ".$this->config["table_prefix"]."pages where STRCMP(tag, '".quote($this->GetPageTag())."')=0 and latest='Y' limit 1"); 
  }
  function LoadRevisions($page) 
  { 
    $rev = $this->LoadAll("select ".$this->pages_meta." from ".$this->config["table_prefix"]."revisions where STRCMP(tag,'".quote($page)."')=0 order by time desc"); 
    if (is_array($rev)) array_unshift($rev, $this->LoadSingle("select ".$this->pages_meta." from ".$this->config["table_prefix"]."pages where STRCMP(tag,'".quote($page)."')=0 order by time desc  limit 1"));
    else $rev[] = $this->LoadSingle("select ".$this->pages_meta." from ".$this->config["table_prefix"]."pages where STRCMP(tag,'".quote($page)."')=0 order by time desc  limit 1");
    return $rev;
  }
  function LoadPagesLinkingTo($tag) { return $this->LoadAll("select from_tag as tag from ".$this->config["table_prefix"]."links where STRCMP(to_tag,'".quote($tag)."')=0 order by tag"); }
  function LoadRecentlyChanged($limit=70)
  {
    $limit= (int) $limit;
    if ($pages = $this->LoadAll("select ".$this->pages_meta." from ".$this->config["table_prefix"]."pages where latest = 'Y' and comment_on = '' order by time desc  limit ".$limit))
    {
      foreach ($pages as $page)
      {
        $this->CachePage($page, 1);
      }

      if ($read_acls = $this->LoadAll("select a.* "
                   ."from ".$this->config["table_prefix"]."acls a, ".$this->config["table_prefix"]."pages p "
                     ."where p.latest = 'Y' "
                     ."and p.comment_on = '' " 
                     ."and a.supertag = p.supertag "
                     ."and privilege = 'read' "
                     ."order by time desc limit ".$limit))
        for ($i=0; $i<count($read_acls); $i++) {
          $this->CacheACL($read_acls[$i]["supertag"], "read", 1,$read_acls[$i]);
        }

      return $pages;
    }
  }
  function LoadWantedPages() 
  { 
    $pref=$this->config["table_prefix"];
    return $this->LoadAll("select distinct ".$pref."links.to_tag as tag,count(".$pref."links.from_tag) as count from ".$pref."links left join ".$pref."pages on ".$pref."links.to_tag = ".$pref."pages.tag where ".$pref."pages.tag is NULL group by tag order by count desc"); 
  }
  function LoadOrphanedPages() 
  { 
    $pref=$this->config["table_prefix"];
    return $this->LoadAll("select distinct tag from ".$pref."pages left join ".$pref."links on ".$pref."pages.tag = ".$pref."links.to_tag where ".$pref."links.to_tag is NULL and ".$pref."pages.comment_on = '' order by tag"); 
  }
  function LoadPageTitles() { return $this->LoadAll("select distinct tag from ".$this->config["table_prefix"]."pages order by tag"); }
  function LoadAllPages() { return $this->LoadAll("select ".$this->pages_meta." from ".$this->config["table_prefix"]."pages where latest = 'Y' order by BINARY tag"); }
  function FullTextSearch($phrase) { return $this->LoadAll("select ".$this->pages_meta." from ".$this->config["table_prefix"]."pages where latest = 'Y' and match(tag, body) against('".quote($phrase)."')"); }
  function TagSearch($phrase) { return $this->LoadAll("select ".$this->pages_meta." from ".$this->config["table_prefix"]."pages where latest = 'Y' and lower(tag) like binary lower('%".quote($phrase)."%') order by supertag"); }

  function SendMail($email,$subject, $message) {
    $headers = "From: \"".$this->GetConfigValue("wakka_name")."\"<".$this->GetConfigValue("admin_email").">\n";
    $headers .= "X-Mailer: PHP/".phpversion()."\n"; //mailer
    $headers .= "X-Priority: 3\n"; //1 UrgentMessage, 3 Normal
    $headers .= "Content-Type: text/html; charset=windows-1251\n";
    @mail($email, $subject, $message, $headers);
  }
  function SavePage($tag, $body, $comment_on = "")
  {
    // get current user
    $user = $this->GetUserName();

    if ($this->HasAccess("write", $tag) || ($comment_on && $this->HasAccess("comment", $comment_on)))
    {
      $body = $this->Format($body, "preformat");
      $body_r = $this->Format($body, "wacko");
      // is page new?
      if (!$oldPage = $this->LoadPage($tag))
      {
        // create default write acl. store empty write ACL for comments.
        // get default acl for root.
        if (strstr($this->context[$this->current_context], "/")) 
        {
          $root = preg_replace( "/^(.*)\\/([^\\/]+)$/", "$1", $this->context[$this->current_context] );
          $write_acl = $this->LoadAcl($root, "write");
          while ($write_acl["default"]==1)
          {
            $_root = $root;
            $root = preg_replace( "/^(.*)\\/([^\\/]+)$/", "$1", $root );
            if ($root == $_root) break;
            $write_acl = $this->LoadAcl($root, "write");
          }
                                                                        $write_acl   = $write_acl["list"];
          $read_acl = $this->LoadAcl($root, "read");                    $read_acl    = $read_acl["list"];
          $comment_acl = $this->LoadAcl($root, "comment");              $comment_acl = $comment_acl["list"];
        }
        else 
        { $write_acl = $this->GetConfigValue("default_write_acl");      
          $read_acl  = $this->GetConfigValue("default_read_acl");       
          $comment_acl = $this->GetConfigValue("default_comment_acl");  
        }

        // current user is owner; if user is logged in! otherwise, no owner.
        if ($this->GetUser()) $owner = $user;
        $this->Query("insert into ".$this->config["table_prefix"]."pages set ".
          ($comment_on ? "comment_on = '".quote($comment_on)."', " : "").
          "time = now(), ".
          "owner = '".quote($owner)."', ".
          "user = '".quote($user)."', ".
          "latest = 'Y', ".
          "supertag = '".$this->NpjTranslit($tag)."', ".
          "body = '".quote($body)."', ".
          "body_r = '".quote($body_r)."', ".
          "tag = '".quote($tag)."'");


        $this->SaveAcl($tag, "write", ($comment_on ? "" : $write_acl));
        $this->SaveAcl($tag, "read", $read_acl);
        $this->SaveAcl($tag, "comment", ($comment_on ? "" : $comment_acl));
        if ($comment_on) {
         $username = $this->GetUserName();
         $Watchers = $this->LoadAll("select * from ".$this->config["table_prefix"]."pagewatches where tag = '".quote($comment_on)."'");
         foreach ($Watchers as $Watcher)
         if ($Watcher["user"] !=  $username)
         {
             $MailAdr = $this->LoadSingle("select email from " .$this->config["table_prefix"]."users where name = '".quote($Watcher["user"])."'");
             $subject = $this->GetResourceValue("Comment for watched page")."'".$comment_on."'";
             $message = $this->GetResourceValue("MailHello"). $Watcher["user"].".<br> <br> ";
             $message .=   $username.
                           $this->GetResourceValue("Someone commented")."<br>  * <a href=\"".$this->Href("",$comment_on,"")."\">".$this->Href("",$comment_on,"")."</a><br>";
             $message .= "<hr>".$this->Format($body_r, "post_links")."<hr>";
             $message .= "<br>".$this->GetResourceValue("MailGoodbye")." ".$this->GetConfigValue("wakka_name");
             $this->SendMail($MailAdr["email"], $subject, $message);
         }
        }
      }
      else
      {
        // aha! page isn't new. keep owner!
        $owner = $oldPage["owner"];
        if ($oldPage['body'] != $body) {
      // move revision
      $this->Query("insert into ".$this->config["table_prefix"]."revisions (tag, time, body, owner, user, latest, handler, comment_on, supertag) ".
          "select tag, time, body, owner, user, 'N', handler, comment_on, supertag from ".$this->config["table_prefix"]."pages WHERE tag = '".quote($tag)."' and latest='Y' LIMIT 1");

      // add new revision
      $this->Query("update ".$this->config["table_prefix"]."pages set ".
        ($comment_on ? "comment_on = '".quote($comment_on)."', " : "").
        "time = now(), ".
        "owner = '".quote($owner)."', ".
        "user = '".quote($user)."', ".
        "supertag = '".$this->NpjTranslit($tag)."', ".
        "body = '".quote($body)."', ".
        "body_r = '".quote($body_r)."'".
        "where tag = '".quote($tag)."' and latest='Y' LIMIT 1");
       }

      $username = $this->GetUserName();
      $Watchers = $this->LoadAll("select * from ".$this->config["table_prefix"]."pagewatches where tag = '".quote($tag)."'");
        if($Watchers)
        {
      foreach ($Watchers as $Watcher)
      if ($Watcher["user"] !=  $username)
      {
          $MailAdr = $this->LoadSingle("select email from " .$this->config["table_prefix"]."users where name = '".quote($Watcher["user"])."'");
          $subject = $this->GetResourceValue("A watched Page changed!")."'".$tag."'";
          $message = "<style>.additions {color: #008800;}\n.deletions {color: #880000;}</style>";
          $message .= $this->GetResourceValue("MailHello"). $Watcher["user"].".<br> <br> ";
          $message .=   $username.
                        $this->GetResourceValue("Someone changed this page:")."<br>  ";//* <a href=\"".$this->Href("",$tag,"")."\">".$this->Href("",$tag,"")."</a><br>";
          $_REQUEST["fastdiff"] = 1;
          $_REQUEST["a"] = -1;
          $page = $this->LoadSingle("select ".$this->pages_meta." from ".$this->config["table_prefix"]."revisions where STRCMP(tag,'".quote($tag)."')=0 order by time desc"); 
          $_REQUEST["b"] = $page["id"];
          $message .= "<hr>".$this->IncludeBuffered("handlers/page/diff.php", "oops")."<hr>";
          $message .= "<br>".$this->GetResourceValue("MailGoodbye")." ".$this->GetConfigValue("wakka_name");
          $this->SendMail($MailAdr["email"], $subject, $message);
      }
      }
    }
    }
    
    if(!($this->GetMicroTime()%3)) $this->WriteRecentChangesXML();
    return $body_r;
  }

  // COOKIES
  function SetSessionCookie($name, $value) { SetCookie($this->config["cookie_prefix"].$name, $value, 0, "/"); $_COOKIE[$this->config["cookie_prefix"].$name] = $value; }
  function SetPersistentCookie($name, $value, $remember = 1) { SetCookie($this->config["cookie_prefix"].$name, $value, time() + ($remember ? 90*24*60*60 : 60 * 60), "/"); $_COOKIE[$this->config["cookie_prefix"].$name] = $value; }
  function DeleteCookie($name) { SetCookie($this->config["cookie_prefix"].$name, "", 1, "/"); $_COOKIE[$this->config["cookie_prefix"].$name] = ""; }
  function GetCookie($name) { return $_COOKIE[$this->config["cookie_prefix"].$name]; }

  // HTTP/REQUEST/LINK RELATED
  function SetMessage($message) { $_SESSION["message"] = $message; }
  function GetMessage() { $message = $_SESSION["message"]; $_SESSION["message"] = ""; return $message; }
  function Redirect($url) { header("Location: $url"); exit; }
  function UnwrapLink( $tag )
  {
    $newtag = $tag;

    if (strstr($this->context[$this->current_context], "/")) 
      $root = preg_replace( "/^(.*)\\/([^\\/]+)$/", "$1", $this->context[$this->current_context] );
                           else $root = "";
    if (preg_match("/^\.\/(.*)$/", $tag, $matches)) { $root=""; }
    else if (preg_match("/^\/(.*)$/", $tag, $matches)) { $root = ""; $newtag = $matches[1]; }
    else if (preg_match("/^\!\/(.*)$/", $tag, $matches)) 
    { 
     $root = $this->context[$this->current_context]; 
     $newtag = $matches[1]; 
    }
    else if (preg_match("/^\.\.\/(.*)$/", $tag, $matches)) 
    { 
     $newtag = $matches[1];  
     if (strstr($root, "/")) 
        $root = preg_replace( "/^(.*)\\/([^\\/]+)$/", "$1", $root );
     else $root = "";
    }
    if ($root != "") $newtag= "/".$newtag;
    $tag = $root.$newtag;
    $tag = str_replace( "//", "/", $tag );
    return $tag;
  }
  function PreLink($tag, $text = "", $track = 1) {
//    if (!$text) $text = $this->AddSpaces($tag);

    if (preg_match("/^[\!\.".ALPHANUM_P."]+$/", $tag))
    {// it's a Wiki link!
      if ($_SESSION["linktracking"] && $track) $this->TrackLinkTo($this->UnwrapLink( $tag ));
    }
    return "".$tag." ==".$text."";
  }
  // returns just PageName[/method].
  function MiniHref($method = "", $tag = "", $addpage = "") 
  { 
   if (!$tag = trim($tag)) $tag = $this->tag;
   if (!$addpage) $tag=$this->SlimUrl($tag);
   $tag = $this->Translit($tag, 0);
   return $tag.($method ? "/".$method : ""); 
  }
  // returns the full url to a page/method.
  function Href($method = "", $tag = "", $params = "", $addpage=0)
  {
   if ($addpage) $params="add=1";
   $href = $this->config["base_url"].$this->MiniHref($method, $tag, $addpage);
   if ($params)
   {
    $href .= ($this->config["rewrite_mode"] ? "?" : "&amp;").$params;
   }
   return $href;
  }
  function ComposeLinkToPage($tag, $method = "", $text = "", $track = 1)
  {
          if (!$text) $text = $this->AddSpaces($tag);
          //$text = htmlentities($text);
          if ($_SESSION["linktracking"] && $track)
                  $this->TrackLinkTo($tag);
          return '<a href="'.$this->href($method, $tag).'">'.$text.'</a>';
  }
  function Link($tag, $method = "", $text = "", $track = 1) {
    $imlink = false;
    if (preg_match("/^[\.".ALPHANUM_P."]+\.(gif|jpg|jpe|jpeg|png)$/", $text))
      $imlink = $this->GetConfigValue("root_url")."/images/".$text;
    else if (preg_match("/^(http|https|ftp):\/\/([^\\s\"<>]+)\.(gif|jpg|jpe|jpeg|png)$/", $text))
      $imlink = $text;
//    $text = htmlspecialchars($text);
    $url = '';


    if (preg_match("/^(mailto[:])?[^\\s\"<>&\:]+\@[^\\s\"<>&\:]+$/", $tag, $matches))
    {// this is a valid Email
      $url = ($matches[1]=="mailto:" ? $tag : "mailto:".$tag); 
      $title = $this->GetResourceValue("MailLink");
      $icon = "<img src=\"".
          $this->GetConfigValue("theme_url")."icons/mail.gif\" alt=\"\" border=\"0\" />";
    }
    else if (preg_match("/^#/", $tag))
    {// html-anchor
      return '<a href="'.$tag.'">'.$text.'</a>';
    }
    else if (preg_match("/^([[:alnum:]]+)[:](".ALPHANUM."*)$/", $tag, $matches))
    {
      $parts = explode("/",$matches[2]);
      for ($i=0;$i<count($parts);$i++) $parts[$i]=urlencode($parts[$i]);
      $url = $this->GetInterWikiUrl($matches[1], implode("/",$parts));
    }
    else if (preg_match("/^[\.".ALPHANUM_P."]+\.(gif|jpg|jpe|jpeg|png)$/", $tag))
    {// image
      return "<img src=\"".$this->GetConfigValue("root_url")."/images/".$tag."\" ".($text?"alt=\"".$text."\" title=\"".$text."\"":"")." />";
    }
    else if (preg_match("/^(http|https|ftp):\/\/([^\\s\"<>]+)\.(gif|jpg|jpe|jpeg|png)$/", $tag))
    {// this is a image with valid external URL
      return "<img src=\"".$tag."\" ".($text?"alt=\"".$text."\" title=\"".$text."\"":"")." />";
    }
    else if (preg_match("/^(http|https|ftp):\/\/([^\\s\"<>]+)\.(gz|tgz|zip|rar|exe|doc|xls|ppt|tgz|pdf)$/", $tag))
    {// this is a file link
      $url = $tag; 
      $title= $this->GetResourceValue("FileLink");
      $icon = "<img src=\"".
            $this->GetConfigValue("theme_url")."icons/file.gif\" alt=\"\" border=\"0\" />";
    } 
    else if (preg_match("/^([A-Za-z0-9_]+\\.)+[A-Za-z][-A-Za-z0-9_&]+$/", $tag)) 
    {// kuso: maybe import regexp from typografica?
      $url = "http://".$tag;
      return $this->Link($url, $method, $text, $track);
    }
    else if (preg_match("/^(http|https|ftp):\/\/([^\\s\"<>]+)$/", $tag))
    {// this is a valid external URL
      $url = $tag; 
      $title= $this->GetResourceValue("OuterLink2");
      $icon = "<img src=\"".
            $this->GetConfigValue("theme_url")."icons/web.gif\" alt=\"\" border=\"0\" />";
    } 
    else if (preg_match("/^([\!\.".ALPHANUM_P."]+)(\#[".ALPHANUM_P."\_]+)?$/", $tag, $matches))
    {// it's a Wiki link!
      $tag = $matches[1];
      if (!$text) $text = $this->AddSpaces($tag);
      $anchor = $matches[2];
      $tag = $this->UnwrapLink( $tag );
      if ($_SESSION["linktracking"] && $track) $this->TrackLinkTo($tag);

      $supertag = $this->NpjTranslit($tag);
      $lockicon = "<img src=\"".$this->GetConfigValue("theme_url")."icons/lock.gif\" align=\"absmiddle\" hspace=\"2\" alt=\"  \" border=\"0\" />";
      $keyicon = "<img src=\"".$this->GetConfigValue("theme_url")."icons/key.gif\" align=\"absmiddle\" hspace=\"2\" alt=\"   \" border=\"0\" />";

      if ($page=$this->LoadPage($tag, "", 1, 1)) {
        $access = $this->HasAccess("read",$tag);
        $result = "<a href=\"".$this->href($method, $page["tag"]).$this->AddDateTime($tag).($anchor?$anchor:"")."\" ".(!$access?" class=\"denied\"":"")." ><nobr>".
         ($imlink ? "<img src=\"$imlink\" border=\"0\" />" :
         (!$access ? $lockicon : 
         ($this->_acl["list"]=="*" ? "" : $keyicon))."".trim($text))."</nobr></a>";
      }
      else
        $result = "<span class=\"missingpage\">".$text."</span>".((($this->method!="print")&&($this->method!="msword"))?"<a href=\"".$this->href("edit", $tag, "", 1)."\">?</a>":"");

      if ($this->GetConfigValue("youarehere_text"))
      if ($this->NpjTranslit($tag) == $this->NpjTranslit($this->context[$this->current_context])) 
        $result = str_replace("####", $text, $this->GetConfigValue("youarehere_text"));

      return $result;
    }
    if (!$text) $text = $tag;
    return $url ? "<a href=\"$url\" target=\"_blank\" title=\"$title\" class=\"outerlink\">".($imlink?"<img src=\"$imlink\" border=\"0\" />":"<nobr>$icon$text</nobr>")."</a>" : $text;

  }
  function AddDatetime($tag)
  {
    if ($user = $this->GetUser()) $show = $user["showdatetime"];
    if (!$show) $show=$this->GetConfigValue("show_datetime");
    if ($show!="N") 
    {
      $_page = $this->LoadPage($tag, "", 1, 1); 
      return ($this->config["rewrite_mode"] ? "?" : "&amp;").
        "v=".base_convert($this->crc16(preg_replace("/[ :\-]/","",$_page["time"])),10,36);
    } else return "";
  }
  function crc16($string) { 
   $crc = 0xFFFF; 
   for ($x = 0; $x < strlen ($string); $x++) { 
     $crc = $crc ^ ord($string[$x]); 
     for ($y = 0; $y < 8; $y++) { 
       if (($crc & 0x0001) == 0x0001) { 
         $crc = (($crc >> 1) ^ 0xA001); 
       } else { $crc = $crc >> 1; } 
     } 
   } 
   return $crc; 
  } 
  function AddSpaces($text)
  {
   if ($user = $this->GetUser()) $show = $user["show_spaces"];
   if (!$show) $show=$this->GetConfigValue("show_spaces");
   if ($show!="N") {
     $text = preg_replace("/(".ALPHANUM.")(".UPPERNUM.")/","\\1&nbsp;\\2",$text);
     $text = preg_replace("/(".UPPERNUM.")(".UPPERNUM.")/","\\1&nbsp;\\2",$text);
     $text = preg_replace("/(".ALPHANUM.")\//","\\1&nbsp;/",$text);
     $text = preg_replace("/(".UPPER.")&nbsp;(?=".UPPER."&nbsp;".UPPERNUM.")/","\\1",$text);
     $text = preg_replace("/(".UPPER.")&nbsp;(?=".UPPER."&nbsp;\/)/","\\1",$text);
     $text = preg_replace("/\/(".ALPHANUM.")/","/&nbsp;\\1",$text);
     $text = preg_replace("/(".UPPERNUM.")&nbsp;(".UPPERNUM.")($|\b)/","\\1\\2",$text);
     $text = preg_replace("/([0-9])(".ALPHA.")/","\\1&nbsp;\\2",$text);
     $text = preg_replace("/(".ALPHA.")([0-9])/","\\1&nbsp;\\2",$text);
     $text = preg_replace("/([0-9])&nbsp;(?=[0-9])/","\\1",$text);
   }
   if (strpos($text, "/")===0) $text = $this->GetResourceValue("RootLinkIcon").substr($text, 1);
   if (strpos($text, "!/")===0) $text = $this->GetResourceValue("SubLinkIcon").substr($text, 2);
   if (strpos($text, "../")===0) $text = $this->GetResourceValue("UpLinkIcon").substr($text, 3);
   return $text;
  }
  function SlimUrl($text)
  {
   $text = $this->NpjTranslit($text, 0);
   $text = str_replace("_", "'", $text);
   if ($this->config["urls_underscores"]==1) 
   {
    $text = preg_replace("/(".ALPHANUM.")(".UPPERNUM.")/","\\1\\2",$text);
    $text = preg_replace("/(".UPPERNUM.")(".UPPERNUM.")/","\\1\\2",$text);
    $text = preg_replace("/(".UPPER.")(?=".UPPER."".UPPERNUM.")/","\\1",$text);
    $text = preg_replace("/(".UPPER.")(?=".UPPER."\/)/","\\1",$text);
    $text = preg_replace("/(".UPPERNUM.")(".UPPERNUM.")($|\b)/","\\1\\2",$text);
    $text = preg_replace("/\/(".UPPERNUM.")/","/\\1",$text);
    $text = str_replace("", "_", $text);
   }
   return $text;
  }
  function IsWikiName($text) { return preg_match("/^".UPPER.LOWER."+".UPPERNUM.ALPHANUM."*$/", $text); }
  function TrackLinkTo($tag) { $_SESSION["linktable"][] = $tag; }
  function GetLinkTable() { return $_SESSION["linktable"]; }
  function ClearLinkTable() { $_SESSION["linktable"] = array(); }
  function StartLinkTracking() { $_SESSION["linktracking"] = 1; }
  function StopLinkTracking() { $_SESSION["linktracking"] = 0; }
  function WriteLinkTable()
  {
    // delete old link table
    $this->Query("delete from ".$this->config["table_prefix"]."links where from_tag = '".quote($this->GetPageTag())."'");
    if ($linktable = $this->GetLinkTable())
    {
      $from_tag = quote($this->GetPageTag());
      foreach ($linktable as $to_tag)
      {
        $lower_to_tag = strtolower($to_tag);
        if (!$written[$lower_to_tag])
        {
          $query.="('".$from_tag."', '".quote($to_tag)."'),";
          $written[$lower_to_tag] = 1;
        }
      }
      $this->Query("insert into ".$this->config["table_prefix"]."links (from_tag, to_tag) VALUES ".rtrim($query,","));
    }
  }
  function Header($mod="") {
    $this->StopLinkTracking();
    $result = $this->IncludeBuffered("header".$mod.".php", "Theme is corrupt", "", "themes/".$this->GetConfigValue("theme")."/appearance");
    $this->StartLinkTracking();
    return $result;
  }
  function Footer($mod="") {
    $this->StopLinkTracking();
    $result = $this->IncludeBuffered("footer".$mod.".php", "Theme is corrupt", "", "themes/".$this->GetConfigValue("theme")."/appearance");
    $this->StartLinkTracking();
    return $result;
  }

  // tabbed theme output routine
  function EchoTab( $link, $hint, $text, $selected=false, $bonus="" )
  {
    $xsize = $selected?7:8;
    $ysize = $selected?25:30;
    if ($text == "") return; // no tab;
    if ($selected) $text = "<a href=\"$link\" title=\"$hint\">".$text."</a>";
    if (!$selected) echo "<div class='TabSelected$bonus' style='background-image:url(".$this->GetConfigValue("theme_url")."icons/tabbg.gif);' >";
    else echo "<div class='Tab$bonus' style='background-image:url(".$this->GetConfigValue("theme_url")."icons/tabbg".($bonus=="2a"?"del":"1").".gif);'>";
    $bonus2 = $bonus=="2a"?"del":"";

    echo '<table cellspacing="0" cellpadding="0" border="0" ><tr>';
      echo "<td><img src='".
            $this->GetConfigValue("theme_url").
            "icons/tabr$selected".$bonus2.".gif' width='$xsize' align='top' hspace='0' vspace='0' height='$ysize' alt='' border='0' /></td>";
      if (!$selected) echo "<td>"; else echo "<td valign='top'>";
        echo "<div class='TabText'>".$text."</div>";
      echo "</td>";
      echo "<td><img src='".
            $this->GetConfigValue("theme_url").
            "icons/tabl$selected".$bonus2.".gif' width='$xsize' align='top' hspace='0' vspace='0' height='$ysize' alt='' border='0' /></td>";
    echo '</tr></table>';
    echo "</div>";
  }

  // FORMS
  function FormOpen($method = "", $tag = "", $formMethod = "POST")
  {
    $result = "<form action=\"".$this->href($method, $tag, "", $_REQUEST["add"])."\" method=\"".$formMethod."\">\n";
    if (!$this->config["rewrite_mode"]) $result .= "<input type=\"hidden\" name=\"wakka\" value=\"".$this->MiniHref($method, $tag, $_REQUEST["add"])."\">\n";
    return $result;
  }
  function FormClose()
  {
    return "</form>\n";
  }

  // INTERWIKI STUFF
  function ReadInterWikiConfig()
  {
    if ($lines = file("interwiki.conf"))
    {
      foreach ($lines as $line)
      {
        if ($line = trim($line))
        {
          list($wikiName, $wikiUrl) = explode(" ", trim($line));
          $this->AddInterWiki($wikiName, $wikiUrl);
        }
      }
    }
  }
  function AddInterWiki($name, $url)
  {
    $this->interWiki[strtolower($name)] = $url;
  }
  function GetInterWikiUrl($name, $tag)
  {
    if ($url = $this->interWiki[strtolower($name)])
    {
      return $url.$tag;
    }
  }

  // REFERRERS
  function LogReferrer($tag = "", $referrer = "")
  {
    // fill values
    if (!$tag = trim($tag)) $tag = $this->GetPageTag();
    if (!$referrer = trim($referrer)) $referrer = $_SERVER["HTTP_REFERER"];

    // check if it's coming from another site
    if ($referrer && !preg_match("/^".preg_quote($this->GetConfigValue("base_url"), "/")."/", $referrer))
    {
      $this->Query("insert into ".$this->config["table_prefix"]."referrers set ".
        "page_tag = '".quote($tag)."', ".
        "referrer = '".quote($referrer)."', ".
        "time = now()");
    }
  }
  function LoadReferrers($tag = "")
  {
    return $this->LoadAll("select referrer, count(referrer) as num from ".$this->config["table_prefix"]."referrers ".($tag = trim($tag) ? "where page_tag = '".quote($tag)."'" : "")." group by referrer order by num desc");
  }

  // PLUGINS
  function Action($action, $forceLinkTracking = 0)
  {
    $action = trim($action);

    // stupid attributes check
    if (stristr($action, "=\""))
    {
      // extract $action and $vars_temp ("raw" attributes)
      preg_match("/^([A-Za-z0-9]*)(.*)$/", $action, $matches);
      list(, $action, $vars_temp) = $matches;

      // match all attributes (key and value)
      preg_match_all("/([A-Za-z0-9]*?)=\"(.*?)\"/", $vars_temp, $matches);

      // prepare an array for extract() to work with (in $this->IncludeBuffered())
      //echo "<pre>";print_r($matches);echo "</pre><hr>";
      if (is_array($matches))
      {
        for ($a = 0; $a < count($matches[0]); $a++)
        {
          $vars[$matches[1][$a]] = $matches[2][$a];
          $vars[$a] = $matches[2][$a];
        }
      }
    }
    if (!$forceLinkTracking) $this->StopLinkTracking();
    $result = $this->IncludeBuffered(strtolower($action).".php", "<i>Unknown action \"$action\"</i>", $vars, $this->config["action_path"]);
    $this->StartLinkTracking();
    return $result;
  }
  function Method($method)
  {
    if ($method=="show") $this->CacheLinks();
    if (!$handler = $this->page["handler"]) $handler = "page";
    $methodLocation = $handler."/".$method.".php";
    return $this->IncludeBuffered($methodLocation, "<i>Unknown method \"$methodLocation\"</i>", "", $this->config["handler_path"]);
  }
  function Format($text, $formatter = "wakka") 
  { 
    $text = $this->IncludeBuffered("formatters/".$formatter.".php", 
    "<i>Formatter \"$formatter\" not found</i>", compact("text")); 
    
    if ($formatter == "wakka" || $formatter == "post_links")
    {
      if ($user = $this->GetUser()) $show = $user["typografica"];
      if ($show !="N") 
      {
        $text = $this->IncludeBuffered("formatters/typografica.php", 
        "<i>Formatter \"$formatter\" not found</i>", compact("text")); 
      } 
    }
    
    return $text; 
  }

  // USERS
  function LoadUser($name, $password = 0) { return $this->LoadSingle("select * from ".$this->config["table_prefix"]."users where STRCMP(name,'".quote($name)."')=0 ".($password === 0 ? "" : "and password = '".quote($password)."'")." limit 1"); }
  function LoadUsers() { return $this->LoadAll("select * from ".$this->config["table_prefix"]."users order by name"); }
  function GetUserName() { 
    if ($user = $this->GetUser()) $name = $user["name"]; 
    else if (strtoupper(substr(PHP_OS, 0, 3)) == 'WIN') $name = $_SERVER["REMOTE_ADDR"];
    else if (!$name = gethostbyaddr($_SERVER["REMOTE_ADDR"])) $name = $_SERVER["REMOTE_ADDR"];
    return $name; 
  }
  function UserName() {  return $this->GetUserName(); }// deprecated!
  function GetUser() { return $_SESSION[$this->config["cookie_prefix"]."user"]; }
  function SetUser($user) { $_SESSION[$this->config["cookie_prefix"]."user"] = $user; $this->SetPersistentCookie("name", $user["name"], 1); $this->SetPersistentCookie("password", $user["password"]); }
  function LogoutUser() { $_SESSION[$this->config["cookie_prefix"]."user"] = ""; $this->DeleteCookie("name"); $this->DeleteCookie("password"); }
  function UserWantsComments() { if (!$user = $this->GetUser()) return false; return ($user["show_comments"] == "Y"); }


  // COMMENTS
  function LoadComments($tag) { return $this->LoadAll("select * from ".$this->config["table_prefix"]."pages where comment_on = '".quote($tag)."' and latest = 'Y' order by time"); }
  function LoadRecentComments() { return $this->LoadAll("select ".$this->pages_meta." from ".$this->config["table_prefix"]."pages where comment_on != '' and latest = 'Y' order by time desc"); }
  function LoadRecentlyCommented($limit = 50)
  {
    // NOTE: this is really stupid. Maybe my SQL-Fu is too weak, but apparently there is no easier way to simply select
    //       all comment pages sorted by their first revision's (!) time. ugh!

    // load ids of the first revisions of latest comments. err, huh?
    if ($ids = $this->LoadAll("select min(id) as id from ".$this->config["table_prefix"]."pages where comment_on != '' group by tag order by id desc"))
    {
      // load complete comments
      foreach ($ids as $id)
      {
        $comment = $this->LoadSingle("select * from ".$this->config["table_prefix"]."pages where id = '".$id["id"]."' limit 1");
        if (!$comments[$comment["comment_on"]] && $num < $limit)
        {
          $comments[$comment["comment_on"]] = $comment;
          $num++;
        }
      }

      // now load pages
      if ($comments)
      {
        // now using these ids, load the actual pages
        foreach ($comments as $comment)
        {
          $page = $this->LoadPage($comment["comment_on"]);
          $page["comment_user"] = $comment["user"];
          $page["comment_time"] = $comment["time"];
          $page["comment_tag"] = $comment["tag"];
          $pages[] = $page;
        }
      }
    }
    // load tags of pages
    //return $this->LoadAll("select comment_on as tag, max(time) as time, tag as comment_tag, user from ".$this->config["table_prefix"]."pages where comment_on != '' group by comment_on order by time desc");
    return $pages;
  }

  // ACCESS CONTROL
  // returns true if logged in user is owner of current page, or page specified in $tag
  function IsAdmin() 
  {
   if (is_array($this->config['aliases'])) 
   {
    $al = $this->config['aliases'];
    $adm = explode("\n", $al['Admins']);
    if (in_array($this->UserName(),$adm))
     return true;
   }
   return false;
  }
  function UserIsOwner($tag = "")
  {
    // check if user is logged in
    if (!$this->GetUser()) return false;

    // set default tag
    if (!$tag = trim($tag)) $tag = $this->GetPageTag();

    // check if user is owner
    if ($this->GetPageOwner($tag) == $this->GetUserName()) return true;
  }
  function GetPageOwner($tag = "", $time = "") { if (!$tag = trim($tag)) $tag = $this->GetPageTag(); if ($page = $this->LoadPage($tag, $time, 1, 1)) return $page["owner"]; }
  function SetPageOwner($tag, $user)
  {
    // check if user exists
    if (!$this->LoadUser($user)) return;

    // updated latest revision with new owner
    $this->Query("update ".$this->config["table_prefix"]."pages set owner = '".quote($user)."' where tag = '".quote($tag)."' and latest = 'Y' limit 1");
  }
  function LoadAcl($tag, $privilege, $useDefaults = 1)
  {
    $supertag = $this->NpjTranslit($tag);
    if ($cachedACL = $this->GetCachedACL($supertag, $privilege, $useDefaults)) $acl = $cachedACL;
    if (!$acl){
      if ($cachedACL = $this->GetCachedACL($tag, $privilege, $useDefaults)) $acl = $cachedACL;

      if (!$acl){

        $acl = $this->LoadSingle("select * from ".$this->config["table_prefix"]."acls where ".
                                 "supertag = '".quote($supertag)."' ".
                                 "and privilege = '".quote($privilege)."' limit 1");
        if (!$acl) 
        {
          $acl = $this->LoadSingle("select * from ".$this->config["table_prefix"]."acls where ".
                                   "page_tag = '".quote($tag)."' ".
                                   "and privilege = '".quote($privilege)."' limit 1");
          if ($acl)
          {
            $this->Query( "update ".$this->config["table_prefix"]."acls ".
                          "set supertag='".$supertag."' where page_tag = '".$tag."';" );
            $acl["supertag"]=$supertag;
          }
        }
        if (!$acl && $useDefaults)
        {
          $acl = array("supertag" => $supertag, "page_tag" => $tag, 
                       "privilege" => $privilege, 
                       "list" => $this->GetConfigValue("default_".$privilege."_acl"),
                       "time" => date("YmdHis"),
                       "default" => "1"
                      );
        }
        $this->CacheACL($supertag, $privilege, $useDefaults,$acl);
      }
    }
    return $acl;
  }

  function SaveAcl($tag, $privilege, $list) {
  
    $supertag = $this->NpjTranslit($tag);
    if ($this->LoadAcl($tag, $privilege, 0)) 
     $this->Query("update ".$this->config["table_prefix"]."acls set list = '".
          quote(trim(str_replace("\r", "", $list)))."' where supertag = '".quote($supertag)."' and privilege = '".quote($privilege)."' ");
    else 
     $this->Query("insert into ".$this->config["table_prefix"]."acls set list = '".
          quote(trim(str_replace("\r", "", $list)))."', ".
          "supertag = '".quote($supertag)."', ".
          "page_tag = '".quote($tag)."', ".
          "privilege = '".quote($privilege)."'");
   
  }
  function RemoveAcls($tag) {
    return $this->Query("delete from ".$this->config["table_prefix"]."acls  where page_tag = '".quote($tag)."' ");
  }
  function RemovePage($tag) {
    return $this->Query("delete from ".$this->config["table_prefix"]."revisions  where tag = '".quote($tag)."' ") &&
    $this->Query("delete from ".$this->config["table_prefix"]."pages  where tag = '".quote($tag)."' ");
  }
  function RemoveComments($tag) {
    return $this->Query("delete from ".$this->config["table_prefix"]."pages  where comment_on = '".quote($tag)."' ");
  }
  function RemoveWatches($tag) {
    return $this->Query("delete from ".$this->config["table_prefix"]."pagewatches  where tag = '".quote($tag)."' ");
  }
  function RemoveLinks($tag) {
    return $this->Query("delete from ".$this->config["table_prefix"]."links  where from_tag = '".quote($tag)."' ");
  }
  function RemoveReferrers($tag) {
    return $this->Query("delete from ".$this->config["table_prefix"]."referrers where page_tag = '".quote($tag)."' ");
  }
  // WATCHES 
  function IsWatched($user, $tag) { 
    return $this->LoadSingle("select * from ".$this->config["table_prefix"]."pagewatches where user = '".quote($user)."' and tag = '".quote($tag)."'"); 
  } 
  
  function SetWatch($user, $tag) { 
    return $this->Query( "insert into ".$this->config["table_prefix"]."pagewatches (user,tag) values ( '".quote($user)."', '".quote($tag)."')" ); 
    // TIMESTAMP type is filled automatically by MySQL 
  } 
  
  function ClearWatch($user, $tag){ 
    return $this->Query( "delete from ".$this->config["table_prefix"]."pagewatches where user = '".quote($user)."' and tag = '".quote($tag)."'"); 
  }

  //aliases stuff
  function ReplaceAliases ($acl)
  {
    if (!is_array($this->config['aliases'])) return $acl;

    foreach ($this->config['aliases'] as $key => $val) {
     $aliases[strtolower($key)]=$val;
    }
    do {
      $list = array();
      $replaced = 0;
      foreach (explode("\n", $acl) as $line)
      {
        // check for inversion character "!"
        if (preg_match("/^[!](.*)$/", $line, $matches))
        {
          $negate = 1;
          $line = $matches[1];
        }
        else
          $negate = 0;

        $linel = strtolower(trim($line));

        if ($aliases[$linel])
        {
          foreach (explode("\n", $aliases[$linel]) as $item)
          {
            $item = trim($item);
            $list[] = ($negate) ? "!{$item}" : $item;
          }
          $replaced++;
        }
        else
          $list[] = $line;
      }
      $acl = join("\n", $list);
    } while ($replaced > 0);
    return $acl;
  }

  // returns true if $user (defaults to current user) has access to $privilege on $page_tag (defaults to current page)
  function HasAccess($privilege, $tag = "", $user = "")
  {
    // see whether user is registered and logged in
   if ($user!="guest@wacko")
   {
    if ($user = $this->GetUser()) $registered = true;

    // set defaults
    if (!$user = $this->GetUserName());
   }
   if (!$tag = trim($tag)) $tag = $this->GetPageTag();
   // load acl
   $acl = $this->LoadAcl($tag, $privilege);
   $acl['list'] = $this->ReplaceAliases($acl['list']);
   $this->_acl = $acl;

    // if current user is owner, return true. owner can do anything!
   if ($user!="guest@wacko") if ($this->UserIsOwner($tag)) return true;
    // fine fine... now go through acl
    foreach (explode("\n", $acl["list"]) as $line)
    {
      $line = trim($line);

      // check for inversion character "!"
      if (preg_match("/^[!](.*)$/", $line, $matches))
      {
        $negate = 1;
        $line = $matches[1];
      }
      else
      {
        $negate = 0;
      }

      // if there's still anything left... lines with just a "!" don't count!
      if ($line)
      {
        switch ($line[0])
        {
        // comments
        case "#":
          break;
        // everyone
        case "*":
          return !$negate;
        // only registered users
        case "$":
        case "":
          return ($registered) ? !$negate : false;
        // aha! a user entry.
        default:
          if ($line == $user)
          {
            return !$negate;
          }
        }
      }
    }

    // tough luck.
    return false;
  }

  // XML
  function WriteRecentChangesXML()
  {
    $xml = "<?xml version=\"1.0\" encoding=\"windows-1251\"?>\n";
    $xml .= "<rss version=\"0.92\">\n";
    $xml .= "<channel>\n";
    $xml .= "<title>".$this->GetConfigValue("wakka_name")." - RecentChanges</title>\n";
    $xml .= "<link>".$this->GetConfigValue("root_url")."</link>\n";
    $xml .= "<description>Recent changes to the ".$this->GetConfigValue("wakka_name")." WakkaWiki</description>\n";
    $xml .= "<language>en-us</language>\n";
    
    if ($pages = $this->LoadRecentlyChanged())
    {
      foreach ($pages as $i => $page)
      {
        if ($this->config["hide_locked"]) $access =$this->HasAccess("read",$page["tag"],"guest@wacko");
        if ($access && ($count < 30)) 
        {
          $count++;
          $xml .= "<item>\n";
          $xml .= "<title>".$page["tag"]."</title>\n";
          $xml .= "<link>".$this->href("show", $page["tag"], "time=".urlencode($page["time"]))."</link>\n";
          $xml .= "<description>".$page["time"]." by ".$page["user"]."</description>\n";
          $xml .= "</item>\n";
        }
      }
    }

    $xml .= "</channel>\n";
    $xml .= "</rss>\n";

    $filename = "xml/recentchanges_".preg_replace("/[^a-zA-Z0-9]/", "", strtolower($this->GetConfigValue("wakka_name"))).".xml";

    $fp = @fopen($filename, "w");
    if ($fp)
    {
      fwrite($fp, $xml);
      fclose($fp);
    }
  }

  // MAINTENANCE
  function Maintenance()
  {
    // purge referrers
    if ($days = $this->GetConfigValue("referrers_purge_time")) {
      $this->Query("delete from ".$this->config["table_prefix"]."referrers where time < date_sub(now(), interval '".quote($days)."' day)");
    }

    // purge old page revisions
    if ($days = $this->GetConfigValue("pages_purge_time")) {
      $this->Query("delete from ".$this->config["table_prefix"]."revisions where time < date_sub(now(), interval '".quote($days)."' day) and latest = 'N'");
    }

    //optimize revisions
    if(!($this->GetMicroTime()%70))
      $this->Query("optimize table ".$this->config["table_prefix"]."revisions");

    //optimize pages
    if(!($this->GetMicroTime()%69))
      $this->Query("optimize table ".$this->config["table_prefix"]."pages");

  }

  // THE BIG EVIL NASTY ONE!
  function Run($tag, $method = "")
  {
    if(!($this->GetMicroTime()%3)) $this->Maintenance(); 
    $this->ReadInterWikiConfig();

    // do our stuff!
    if (!$this->method = trim($method)) $this->method = "show";
    if (!$this->tag = trim($tag)) $this->Redirect($this->href("", $this->config["root_page"]));
    if ((!$this->GetUser() && $_COOKIE[$this->config["cookie_prefix"]."name"]) && ($user = $this->LoadUser($_COOKIE[$this->config["cookie_prefix"]."name"], $_COOKIE[$this->config["cookie_prefix"]."password"]))) $this->SetUser($user);
    if (!preg_match("/^[".ALPHANUM_P."\!]+$/", $tag))
     if (preg_match("/^[".ALPHANUM_P."\!]+$/", $t1=utf_decode($tag)))
      $tag = $t1;
//    if (!$_REQUEST["add"]=="1" || $this->method=="watch" ) 
    $tag = str_replace("'", "_", str_replace("\\", "", str_replace("_", "", $tag)));

    $this->tag=$this->Translit($tag, 1);
    $this->supertag = $this->NpjTranslit($tag);
    $this->SetPage($this->LoadPage($this->tag, $_REQUEST["time"]));
    $this->LogReferrer();

    header("Last-Modified: ".gmdate("D, d M Y H:i:s", strtotime($this->page["time"]))." GMT");;
    if (preg_match("/(\.xml)$/", $this->method))
    {
      print($this->Method($this->method));
    }
    else if (preg_match("/print$/", $this->method))
    {
      print($this->Header("print").$this->Method($this->method).$this->Footer("print"));
    }
    else if (preg_match("/msword$/", $this->method))
    {
      print($this->Header("msword").$this->Method($this->method).$this->Footer("print"));
    }
    else
    {
      $this->current_context++;
      $this->context[$this->current_context] = $this->tag;
      $data = $this->Method($this->method);
      $this->current_context--;
      print($this->Header().$data.$this->Footer());
    }
   return $this->tag;
  }

  function AvailableLanguages()
  {
   $handle=opendir("lang");
   while (false!==($file = readdir($handle))) {
     if ($file != "." && $file != ".." && !is_dir($file) && 1==preg_match("/^wakka\.(.*?)\.php$/",$file,$match)) {
       $langlist[] = $match[1];
     }
   }
   closedir($handle);
   return $langlist;
  }

  // BREADCRUMBS -- additional navigation added with WackoClusters
  function GetPagePath()
  {
    $steps = explode("/", $this->tag);
    $result = "";
    $links = array();
    $_links = array();
    for ($i=0;$i<count($steps)-1;$i++)
    {
      if ($i==0) $prev=""; else $prev=$links[$i-1]."/"; 
      $links[] =  $prev.$steps[$i];
    }
    for ($i=0;$i<count($steps)-1;$i++)
      $result.= $this->Link( $links[$i], "", $steps[$i] )."/";
    $result.=$steps[count($steps)-1];
    return $result;
  }

  // TOC AUTO NUMERATION -- prima vera bonus to {{TableOfContents}}
  function tocRecursion( $pageroot, $data, $startlevel=1, $depth=1 )
  {
    // 1. found next inlined <hX>
    $found=0;
    for ( ; $startlevel<7; $startlevel++ )
    {
       $re = "/<a name=\"(TOC_[0-9]+)\"><\/a><h".$startlevel.">(.*?)<\/h".$startlevel.">(.*?)".
              "((?=\<a name=\"TOC_[0-9]+\"><\/a><h".$startlevel.">)|$)/si";
       $found = preg_match_all( $re, $data, $level, PREG_PATTERN_ORDER );
       if ($found) break;  
    }
    // 2. output one list & ask for recursion
    if ($found)
    {
      print "<div class=\"Toc".$depth."\">";
      for ( $i=0; $i<$found; $i++ )
      {
        print "<div>";
          print "<a href=\"".$pageroot."#".$level[1][$i]."\">";
           print $level[2][$i];
          print "</a>";
          $this->tocRecursion( $pageroot, $level[3][$i], $startlevel+1, $depth+1 );
        print "</div>";
      }
      print "</div>";
    }
  }
  function tocToggleAutoNumerate( $value = 1 )
  { $this->tocAutoNumerate = $value; }
  function tocEnumerate( $what, $startlevel=1, $depth=1, $numberstring="" )
  {
    // 1. found next inlined <hX>
    $found=0;
    for ( ; $startlevel<7; $startlevel++ )
    {
       $re = "/<a name=\"(TOC_[0-9]+)\"><\/a><h".$startlevel.">(.*?)<\/h".$startlevel.">(.*?)".
              "((?=\<a name=\"TOC_[0-9]+\"><\/a><h".$startlevel.">)|$)/si";
       $found = preg_match_all( $re, $what, $level, PREG_PATTERN_ORDER );
       if ($found) break;  
    }
    // 2. output one list & ask for recursion
    if ($found)
    {
      for ( $i=0; $i<$found; $i++ )
      {
        $newnumber = $numberstring.($i+1).".";
        $newheader = str_replace( "<h".$startlevel.">", "<h".$startlevel.">".$newnumber." ", $level[0][$i] );
        $newbody   = $this->tocEnumerate( $level[3][$i], $startlevel+1, $depth+1, $newnumber );
        $newheader = str_replace( $level[3][$i], $newbody, $newheader );
        $what      = str_replace( $level[0][$i], $newheader, $what );
      }
    }
    return $what;
  }
  
  function TreeView($node,$level,$indent=0)
  {
    if ($level>0)
    {
    $head=split(" :: ",str_replace("]]", "", str_replace("[[", "", $this->GetConfigValue("navigation_links"))));
    // we don't want page from the header  

    if (!in_array($node, $head, TRUE)) 
    {
      if ((($indent>0) && ($this->GetConfigValue("root_page")!=$node)) || ($indent==0))
      {

          if ($indent)
            print((str_repeat("&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;",$indent)).$this->Link("/".$node, "", $node)."<br/>\n");

            $pages = $this->LoadAll("select to_tag from ".$this->config["table_prefix"]."links, ".$this->config["table_prefix"]."pages where STRCMP(from_tag,'".quote($node)."')=0 AND ".$this->config["table_prefix"]."links.to_tag = ".$this->config["table_prefix"]."pages.tag order by to_tag asc");

          if (is_array($pages)) {
            foreach ($pages as $page)
            {
              $this->CachePage($page["to_tag"]);
              if ($this->HasAccess("read",$page["to_tag"])){

                $this->TreeView($page["to_tag"],$level-1,$indent+1);
              }
            }
          }
      }
    }
  }
  }
  function RenamePage($tag, $NewTag, $NewSuperTag="")
  {
    if ($NewSuperTag=="")
      $NewSuperTag = NpjTranslit($NewTag);

    return $this->Query("update ".$this->config["table_prefix"]."revisions set tag = '".quote($NewTag)."', supertag = '".quote($NewSuperTag)."' where tag = '".quote($tag)."' ") &&
    $this->Query("update ".$this->config["table_prefix"]."pages  set tag = '".quote($NewTag)."', supertag = '".quote($NewSuperTag)."' where tag = '".quote($tag)."' ");
  } 
  function RenameAcls($tag, $NewTag, $NewSuperTag="") {
    if ($NewSuperTag=="")
      $NewSuperTag = NpjTranslit($NewTag);
    return $this->Query("update ".$this->config["table_prefix"]."acls set page_tag = '".quote($NewTag)."', supertag = '".quote($NewSuperTag)."' where page_tag = '".quote($tag)."' ");
  }
  function RenameComments($tag, $NewTag, $NewSuperTag="") {
    return $this->Query("update ".$this->config["table_prefix"]."pages set comment_on = '".quote($NewTag)."'  where comment_on = '".quote($tag)."' ");
  }
  function RenameWatches($tag, $NewTag, $NewSuperTag="") {
    return $this->Query("update ".$this->config["table_prefix"]."pagewatches set tag = '".quote($NewTag)."' where tag = '".quote($tag)."' ");
  }
  function RenameLinks($tag) {
    return $this->Query("update ".$this->config["table_prefix"]."links set from_tag = '".quote($NewTag)."' where from_tag = '".quote($tag)."' ");
  }

}

// stupid version check
if (!isset($_REQUEST)) die('$_REQUEST[] not found. Wakka requires PHP 4.1.0 or higher!');

// workaround for the amazingly annoying magic quotes.
function magicQuotesSuck(&$a)
{
  if (is_array($a))
  {
    foreach ($a as $k => $v)
    {
      if (is_array($v))
        magicQuotesSuck($a[$k]);
      else
        $a[$k] = stripslashes($v);
    }
  }
}
set_magic_quotes_runtime(0);
if (get_magic_quotes_gpc())
{
  magicQuotesSuck($_POST);
  magicQuotesSuck($_GET);
  magicQuotesSuck($_COOKIE);
}

// default configuration values
$wakkaDefaultConfig = array(
  "mysql_host"      => "localhost",
  "mysql_database"    => "wakka",
  "mysql_user"      => "wakka",
  "table_prefix"      => "wakka_",
  "cookie_prefix"      => "wakka_",

  "root_page"       => "HomePage",
  "wakka_name"      => "MyWackoSite",
  "base_url"        => "http://".$_SERVER["SERVER_NAME"].($_SERVER["SERVER_PORT"] != 80 ? ":".$_SERVER["SERVER_PORT"] : "").preg_replace("/(\?|&)installAction=default/","",$_SERVER["REQUEST_URI"]).(preg_match("/wakka\.php/", $_SERVER["REQUEST_URI"]) ? "?wakka=" : ""),
  "rewrite_mode"      => (preg_match("/wakka\.php/", $_SERVER["REQUEST_URI"]) ? "0" : "1"),

  "action_path"     => "actions",
  "handler_path"      => "handlers",

  "language"     => "en",
  "theme"      => "default",

  "header_action"     => "header",
  "footer_action"     => "footer",

  "show_datetime"     => "Y",
  "show_spaces"     => "Y",

  "site_bookmarks" => "PageIndex / RecentChanges / RecentlyCommented",
  "default_bookmarks" => "PageIndex\nRecentChanges\nRecentlyCommented\n((Registration))",
  "default_typografica" => 1,
  "default_showdatetime" => 1,

  "referrers_purge_time"  => 1,
  "pages_purge_time"    => 0,

  "hide_comments"     => 0,
  "debug"     => 0,
  "youarehere_text"     => "",
  "hide_locked"     => 1,
  "allow_rawhtml" => 0,
  "urls_underscores" => 0,

  "allrecentchanges_page" => "", 
  "allpageindex_page" => "",

  "default_write_acl"   => "*",
  "default_read_acl"    => "*",
  "default_comment_acl" => "*",
  "default_rename_redirect" => 1
  );
$wakkaDefaultConfig['aliases'] = array('Admins' => "",);


// load config
if (!$configfile = GetEnv("WAKKA_CONFIG")) $configfile = "wakka.config.php";
if (file_exists($configfile)) include($configfile);
$wakkaConfigLocation = $configfile;
$wakkaConfig = array_merge($wakkaDefaultConfig, $wakkaConfig);

// check for locking
if (file_exists("locked")) {
  // read password from lockfile
  $lines = file("locked");
  $lockpw = trim($lines[0]);

  // is authentification given?
  if (isset($_SERVER["PHP_AUTH_USER"])) {
    if (!(($_SERVER["PHP_AUTH_USER"] == "admin") && ($_SERVER["PHP_AUTH_PW"] == $lockpw))) {
      $ask = 1;
    }
  } else {
    $ask = 1;
  }

  if ($ask) {
    header("WWW-Authenticate: Basic realm=\"".$wakkaConfig["wakka_name"]." Install/Upgrade Interface\"");
    header("HTTP/1.0 401 Unauthorized");
    print("This site is currently being upgraded. Please try again later.");
    exit;
    }
}


// compare versions, start installer if necessary
if ($wakkaConfig["wakka_version"] != WAKKA_VERSION || $wakkaConfig["wacko_version"] != WACKO_VERSION)
{
  if (!$_REQUEST["installAction"] ) 
  {
   $req = $_SERVER["REQUEST_URI"];
   if ($req{strlen($req)-1}!="/" && strstr($req, ".php")!=".php") {
    header("Location: http://".$_SERVER["SERVER_NAME"].$_SERVER["REQUEST_URI"]."/");
    exit;
   }
  }
  // start installer
  if (!$installAction = trim($_REQUEST["installAction"])) $installAction = "lang";
  include("setup/header.php");
  if (file_exists("setup/".$installAction.".php")) include("setup/".$installAction.".php"); else print("<em>Invalid action</em>");
  include("setup/footer.php");
  exit;
}

// start session
session_start();

// load dbal
if (!$wakkaConfig["db_layer"]) $wakkaConfig["db_layer"] = "mysql";
$dbfile = "db/".$wakkaConfig["db_layer"].".php";
if (file_exists($dbfile)) include($dbfile);
else die("Error loading DBAL.");

// set root_url & theme_url
$wakkaConfig["root_url"]=preg_replace("#/[^/]*$#","/",$wakkaConfig["base_url"]);
$wakkaConfig["theme_url"]=$wakkaConfig["root_url"]."themes/".$wakkaConfig["theme"]."/";

// fetch wakka location
$wakka = $_REQUEST["wakka"];

// remove leading slash
$wakka = preg_replace("/^\//", "", $wakka);

// split into page/method
$p = strrpos($wakka, "/");
if ($p === false) { 
 $page = $wakka;
} else {
 $page = substr($wakka, 0, $p);
 $m1 = $method = substr($wakka, $p-strlen($wakka)+1);
 if (!file_exists($wakkaConfig["handler_path"]."/page/".$method.".php")) {
  $page = $wakka;
  $method = "";
 }
}

// create wakka object
$wakka = new Wakka($wakkaConfig);
$wakka->headerCount = 0;

// load resource
if ($thisuser = $wakka->GetUser()) $thislang=$thisuser["lang"];
if ($thislang!="") $wakkaConfig["language"]=$thislang;
if (!isset($wakkaConfig["language"])) $wakkaConfig["language"]="en";
$resourcefile = "lang/wakka.".$wakkaConfig["language"].".php";
if (file_exists($resourcefile)) include($resourcefile);
$wakkaResourceLocation = $resourcefile;
// theme
$themeresourcefile = "themes/".$wakkaConfig["theme"]."/lang/wakka.".$wakkaConfig["language"].".php";
if (file_exists($themeresourcefile)) include($themeresourcefile);
$wakkaResource = array_merge($wakkaResource, $themeResource);
// set resource
$wakka->SetResource($wakkaResource);

if ($method != "show") unset($wakka->config["youarehere_text"]); 

// go!
$pg=$wakka->Run($page, $method);

// ,    
$ddd=microtime();
$ddd=((double)strstr($ddd, ' ')+(double)substr($ddd,0,strpos($ddd,' ')));
if ($wakka->GetConfigValue("debug")>=1 && strpos($method,".xml")===false && $method!="print") echo ("<div style='margin:5px 20px; color:#999999'><small> : ".(number_format(($ddd-$ttt),3))." </small></div>");

//.
function utf_decode($string) {
//   strtr()
$tran = array(
 "%D0%81"=>"%A8",
 "%D1%91"=>"%B8",
 "%D0%90"=>"%C0",
 "%D0%91"=>"%C1",
 "%D0%92"=>"%C2",
 "%D0%93"=>"%C3",
 "%D0%94"=>"%C4",
 "%D0%95"=>"%C5",
 "%D0%96"=>"%C6",
 "%D0%97"=>"%C7",
 "%D0%98"=>"%C8",
 "%D0%99"=>"%C9",
 "%D0%9A"=>"%CA",
 "%D0%9B"=>"%CB",
 "%D0%9C"=>"%CC",
 "%D0%9D"=>"%CD",
 "%D0%9E"=>"%CE",
 "%D0%9F"=>"%CF",
 "%D0%A0"=>"%D0",
 "%D0%A1"=>"%D1",
 "%D0%A2"=>"%D2",
 "%D0%A3"=>"%D3",
 "%D0%A4"=>"%D4",
 "%D0%A5"=>"%D5",
 "%D0%A6"=>"%D6",
 "%D0%A7"=>"%D7",
 "%D0%A8"=>"%D8",
 "%D0%A9"=>"%D9",
 "%D0%AA"=>"%DA",
 "%D0%AB"=>"%DB",
 "%D0%AC"=>"%DC",
 "%D0%AD"=>"%DD",
 "%D0%AE"=>"%DE",
 "%D0%AF"=>"%DF",
 "%D0%B0"=>"%E0",
 "%D0%B1"=>"%E1",
 "%D0%B2"=>"%E2",
 "%D0%B3"=>"%E3",
 "%D0%B4"=>"%E4",
 "%D0%B5"=>"%E5",
 "%D0%B6"=>"%E6",
 "%D0%B7"=>"%E7",
 "%D0%B8"=>"%E8",
 "%D0%B9"=>"%E9",
 "%D0%BA"=>"%EA",
 "%D0%BB"=>"%EB",
 "%D0%BC"=>"%EC",
 "%D0%BD"=>"%ED",
 "%D0%BE"=>"%EE",
 "%D0%BF"=>"%EF",
 "%D1%80"=>"%F0",
 "%D1%81"=>"%F1",
 "%D1%82"=>"%F2",
 "%D1%83"=>"%F3",
 "%D1%84"=>"%F4",
 "%D1%85"=>"%F5",
 "%D1%86"=>"%F6",
 "%D1%87"=>"%F7",
 "%D1%88"=>"%F8",
 "%D1%89"=>"%F9",
 "%D1%8A"=>"%FA",
 "%D1%8B"=>"%FB",
 "%D1%8C"=>"%FC",
 "%D1%8D"=>"%FD",
 "%D1%8E"=>"%FE",
 "%D1%8F"=>"%FF",
 );
   $string = strtr(urlencode($string),$tran);
   $string = urldecode($string);
return $string;
}

?>
